image: openjdk:8-jdk

variables:
  ANDROID_COMPILE_SDK: "28"
  ANDROID_BUILD_TOOLS: "28.0.3"
  ANDROID_SDK_TOOLS:   "4333796"
  GIT_SUBMODULE_STRATEGY: recursive

before_script:
  - apt-get --quiet update --yes
  - apt-get --quiet install --yes wget tar unzip lib32stdc++6 lib32z1
  - wget --quiet --output-document=android-sdk.zip https://dl.google.com/android/repository/sdk-tools-linux-${ANDROID_SDK_TOOLS}.zip
  - unzip -q -d android-sdk-linux android-sdk.zip
  - echo y | android-sdk-linux/tools/bin/sdkmanager "platforms;android-${ANDROID_COMPILE_SDK}" >/dev/null
  - echo y | android-sdk-linux/tools/bin/sdkmanager "platform-tools" >/dev/null
  - echo y | android-sdk-linux/tools/bin/sdkmanager "build-tools;${ANDROID_BUILD_TOOLS}" >/dev/null
  - export ANDROID_HOME=$PWD/android-sdk-linux
  - export PATH=$PATH:$PWD/android-sdk-linux/platform-tools/
  - chmod +x ./gradlew
  # temporarily disable checking for EPIPE error and use yes to accept all licenses
  - set +o pipefail
  - yes | android-sdk-linux/tools/bin/sdkmanager --licenses >/dev/null
  - set -o pipefail

stages:
  - build
  - test

lintDebug:
  stage: build
  only:
    refs:
      - build
  script:
    - ./gradlew -Pci --console=plain :app:lintDevDebug -PbuildDir=lint

assembleDevDebug:
  stage: build
  only:
    refs:
      - build
  script:
    - ./gradlew assembleDevDebug
    - mv app/build/outputs/apk/dev/debug/*.apk ./
  artifacts:
    paths:
    - ./*.apk

assembleNormalRelease:
  stage: build
  only:
    refs:
      - release
  script:
    - cat $KEY_STORE_FILE | base64 -d > my.keystore
    - ./gradlew assembleNormalRelease
          -Pandroid.injected.signing.store.file=$(pwd)/my.keystore
          -Pandroid.injected.signing.store.password="$KEY_STORE_PASSWORD"
          -Pandroid.injected.signing.key.alias=$KEY_ALIAS
          -Pandroid.injected.signing.key.password="$KEY_PASSWORD"
    - mv app/build/outputs/apk/normal/release/*.apk ./
  artifacts:
    paths:
    - ./*.apk
    - CHANGELOG.md

assemblePlayRelease:
  stage: build
  only:
    refs:
      - release
  script:
    - cat $KEY_STORE_FILE | base64 -d > my.keystore
    - ./gradlew assemblePlayRelease
          -Pandroid.injected.signing.store.file=$(pwd)/my.keystore
          -Pandroid.injected.signing.store.password="$KEY_STORE_PASSWORD"
          -Pandroid.injected.signing.key.alias=$KEY_ALIAS
          -Pandroid.injected.signing.key.password="$KEY_PASSWORD"
    - mv app/build/outputs/apk/play/release/*.apk ./
  artifacts:
    paths:
    - ./*.apk
    - CHANGELOG.md

debugTests:
  stage: test
  only:
    refs:
      - build
  script:
    - ./gradlew -Pci --console=plain :app:testDevDebug

